## charmtimetracker 1.10.0

=== CMakeLists.txt ===
PROJECT( Charm )
IF( NOT Charm_VERSION )
    FIND_PACKAGE( Git QUIET )
    IF( EXISTS ${GIT_EXECUTABLE} )
        EXECUTE_PROCESS( COMMAND ${GIT_EXECUTABLE} describe --tags --abbrev=1
            RESULT_VARIABLE GIT_RESULT
            OUTPUT_VARIABLE Charm_VERSION
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_STRIP_TRAILING_WHITESPACE )
        IF( NOT GIT_RESULT EQUAL 0 )
            MESSAGE( FATAL_ERROR "Cannot get 'git describe' version!" )
        ENDIF()
    ENDIF()
ENDIF()

STRING( REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.(.*)$" Charm_VERSION "${Charm_VERSION}")
SET( Charm_VERSION_MAJOR "${CMAKE_MATCH_1}" )
SET( Charm_VERSION_MINOR "${CMAKE_MATCH_2}" )
SET( Charm_VERSION_PATCH "${CMAKE_MATCH_3}" )
SET( Charm_VERSION_COUNT 3 )

IF( NOT ( DEFINED Charm_VERSION_MAJOR AND DEFINED Charm_VERSION_MINOR AND DEFINED Charm_VERSION_PATCH ) )
    MESSAGE( FATAL_ERROR "No Git executable or valid Charm version argument found.\n"
    "Please pass a version to CMake e.g. cmake -DCharm_VERSION=1.0.0" )
ENDIF()

IF( NOT CMAKE_BUILD_TYPE )
    SET( CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE )
ENDIF()

IF( APPLE AND CMAKE_INSTALL_PREFIX MATCHES "/usr/local" )
    SET( CMAKE_INSTALL_PREFIX "/Applications" )
ENDIF()

MESSAGE( STATUS "Building Charm ${Charm_VERSION} in ${CMAKE_BUILD_TYPE} mode" )

CMAKE_MINIMUM_REQUIRED( VERSION 2.6.0 )
SET( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMake" )

if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
endif()

SET( CMAKE_AUTOMOC ON )

OPTION( CHARM_FORCE_QT4 "Force building Charm with Qt4" OFF )

# try Qt5 first, and prefer that if found
IF( NOT CHARM_FORCE_QT4 )
    find_package( Qt5Core QUIET )
ENDIF()

IF(Qt5Core_FOUND)
    find_package(Qt5Widgets REQUIRED)
    find_package(Qt5Xml REQUIRED)
    find_package(Qt5Network REQUIRED)
    find_package(Qt5Sql REQUIRED)
    find_package(Qt5Test REQUIRED)

    find_package(Qt5PrintSupport)
    IF(Qt5PrintSupport_FOUND)
        include_directories(${Qt5PrintSupport_INCLUDE_DIRS})
        set(QTPRINT_LIBRARIES ${Qt5PrintSupport_LIBRARIES})
    ENDIF()

    SET(CHARM_MAC_HIGHRES_SUPPORT_ENABLED ON)

    IF(WIN32)
        SET(QT_PLATFORM_SPECIFIC_LIBRARIES Qt5::WinMain)
    ELSE()
        SET(QT_PLATFORM_SPECIFIC_LIBRARIES)
    ENDIF()

    IF(APPLE)
        find_package(Qt5MacExtras REQUIRED)
        include_directories(${Qt5MacExtras_INCLUDE_DIRS})
        set(QT_PLATFORM_SPECIFIC_LIBRARIES ${Qt5MacExtras_LIBRARIES})
    ENDIF()

    IF(UNIX AND NOT APPLE)
        find_package(Qt5DBus)
        IF(Qt5DBus_FOUND)
            set(HAVE_DBUS ON)
            include_directories(${Qt5DBus_INCLUDE_DIRS})
            set(QTDBUS_LIBRARIES ${Qt5DBus_LIBRARIES})
            macro(qt_add_dbus_interface)
                qt5_add_dbus_interface(${ARGN})
            endmacro()
        ELSE()
            set(QTDBUS_LIBRARIES "")
            macro(qt_add_dbus_interface)
                # do nothing
            endmacro()
        ENDIF()
    ENDIF()

    macro(qt_wrap_cpp)
        qt5_wrap_cpp(${ARGN})
    endmacro()
    macro(qt_wrap_ui)
        qt5_wrap_ui(${ARGN})
    endmacro()
    macro(qt_add_resources)
        qt5_add_resources(${ARGN})
    endmacro()

    #set(QTCORE_LIBRARIES ${Qt5Core_LIBRARIES})
    set(QT_QTTEST_LIBRARY ${Qt5Test_LIBRARIES})

    set(QT_LIBRARIES
        ${Qt5Core_LIBRARIES}
        ${Qt5Widgets_LIBRARIES}
        ${Qt5Xml_LIBRARIES}
        ${Qt5Network_LIBRARIES}
        ${Qt5Sql_LIBRARIES}
        ${QTPRINT_LIBRARIES}
        ${QTDBUS_LIBRARIES}
        ${QT_PLATFORM_SPECIFIC_LIBRARIES}
    )

    include_directories(
        ${Qt5Core_INCLUDE_DIRS}
        ${Qt5Widgets_INCLUDE_DIRS}
        ${Qt5Xml_INCLUDE_DIRS}
        ${Qt5Network_INCLUDE_DIRS}
        ${Qt5Sql_INCLUDE_DIRS}
    )

    SET( CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}" )
ELSE()
    # No Qt5 found, try Qt4
    find_package(Qt4 COMPONENTS QtMain QtCore QtGui QtSql QtXml QtNetwork REQUIRED)
    INCLUDE( UseQt4 )

    SET(CHARM_MAC_HIGHRES_SUPPORT_ENABLED OFF)

    IF(UNIX AND NOT APPLE)
        find_package(Qt4 COMPONENTS QtDBus)
        IF (QT_QTDBUS_FOUND)
            set(HAVE_DBUS ON)
            set(QTDBUS_LIBRARIES ${QT_QTDBUS_LIBRARY})
            macro(qt_add_dbus_interface)
                qt4_add_dbus_interface(${ARGN})
            endmacro()
        ENDIF()
    ENDIF()

    IF (NOT QT_QTDBUS_FOUND)
        set(QTDBUS_LIBRARIES "")
        macro(qt_add_dbus_interface)
            # do nothing
        endmacro()
    ENDIF()

    include_directories(${QT_INCLUDES})
    #set(QTCORE_LIBRARIES ${QT_QTCORE_LIBRARY})

    macro(qt_wrap_cpp)
        qt4_wrap_cpp(${ARGN})
    endmacro()
    macro(qt_wrap_ui)
        qt4_wrap_ui(${ARGN})
    endmacro()
    macro(qt_add_resources)
        qt4_add_resources(${ARGN})
    endmacro()
ENDIF()

ENABLE_TESTING()

IF( APPLE AND "${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}" VERSION_EQUAL "4.8.0" )
    MESSAGE( WARNING "Qt 4.8.0 is rather broken on OSX.\n"
                     "Known bugs in Charm include global keyboard shortcuts.\n"
                     "Qt 4.7.4 is the current recommended version on OSX." )
ENDIF()

IF( CMAKE_BUILD_TYPE MATCHES "^[Rr]elease$" )
    ADD_DEFINITIONS( -DQT_NO_DEBUG_OUTPUT )
ENDIF()

# Always include the source and build directories in the include path
# to save doing so manually in every subdirectory.
SET( CMAKE_INCLUDE_CURRENT_DIR ON )

# Put the include directories which are in the source or build tree
# before all other include directories so they are preferred over
# any installed Charm headers.
SET( CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON )

IF( CMAKE_COMPILER_IS_GNUCXX )
    # Add additional GCC options.
    ADD_DEFINITIONS(
        -Wall -Wundef -Wcast-align -Wchar-subscripts -Wpointer-arith
        -Wwrite-strings -Wpacked -Wformat-security
        -Wmissing-format-attribute -Wold-style-cast
    )
    ADD_DEFINITIONS( -fvisibility=hidden )
ELSEIF( CMAKE_CXX_COMPILER MATCHES "clang" )
    ADD_DEFINITIONS( -Wall -Wextra -Wno-unused-parameter )
    ADD_DEFINITIONS( -fvisibility=hidden )
ENDIF()


IF( UNIX AND NOT APPLE )
    set( Charm_EXECUTABLE charmtimetracker )
    SET( BIN_INSTALL_DIR bin )
    SET( DOC_INSTALL_DIR share/doc/${Charm_EXECUTABLE} )
ELSE()
    set( Charm_EXECUTABLE Charm )
    SET( BIN_INSTALL_DIR . )
    SET( DOC_INSTALL_DIR . )
ENDIF()
SET( ICONS_DIR "${CMAKE_SOURCE_DIR}/Charm/Icons" )

OPTION( CHARM_IDLE_DETECTION "Build the Charm idle detector" ON )
OPTION( CHARM_TIMESHEET_TOOLS "Build the Charm timesheet tools" OFF )
set( CHARM_IDLE_TIME "360" CACHE STRING "Set the idle timeout (in seconds, default 360)" )
OPTION( CHARM_CI_SUPPORT "Build Charm with command interface support" OFF )

IF( CHARM_CI_SUPPORT )
    OPTION( CHARM_CI_TCPSERVER "Build Charm with TCP command interface support" ON )
    OPTION( CHARM_CI_LOCALSERVER "Build Charm with local socket command interface support" ON )
ENDIF()

ADD_SUBDIRECTORY( Core )
ADD_SUBDIRECTORY( Charm )

IF( CHARM_TIMESHEET_TOOLS AND UNIX )
    # Only build the tools if they are explicitly requested to avoid
    # the Qt MySQL driver dependency.
    ADD_SUBDIRECTORY( Tools/TimesheetProcessor )
    ADD_SUBDIRECTORY( Tools/TimesheetGenerator )
    MESSAGE( STATUS "Building the Charm timesheet tools")
ENDIF()

ADD_SUBDIRECTORY( Tests )

CONFIGURE_FILE( CharmCMake.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/CharmCMake.h )

SET( LICENSE_FILE "License.txt" )
SET( README_FILE "ReadMe.txt" )
IF( NOT APPLE )
    INSTALL( FILES "${LICENSE_FILE}" "${README_FILE}" DESTINATION ${DOC_INSTALL_DIR} )
ENDIF()

    # Only support CPack packaging on newer versions of CMake.
IF( NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.4" )
    SET( CPACK_GENERATOR "TBZ2" )
    SET( CPACK_PACKAGE_VERSION_MAJOR "${Charm_VERSION_MAJOR}" )
    SET( CPACK_PACKAGE_VERSION_MINOR "${Charm_VERSION_MINOR}" )
    SET( CPACK_PACKAGE_VERSION_PATCH "${Charm_VERSION_PATCH}" )
    SET( CPACK_PACKAGE_VERSION "${Charm_VERSION}" )
    SET( CPACK_PACKAGE_VENDOR "KDAB" )
    SET( CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/${README_FILE}" )
    IF( WIN32 )
        SET( CPACK_GENERATOR "NSIS" "ZIP" )
        SET( CPACK_PACKAGE_EXECUTABLES "Charm" "Charm" )
        SET( CPACK_PACKAGE_INSTALL_DIRECTORY "Charm" )
        SET( CPACK_PACKAGE_FILE_NAME "Charm ${Charm_VERSION}" )
        SET( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/${LICENSE_FILE}" )
        SET( CPACK_NSIS_EXECUTABLES_DIRECTORY "${BIN_INSTALL_DIR}" )
        SET( CPACK_NSIS_MUI_ICON "${ICONS_DIR}/Charm.ico" )
        SET( CPACK_PACKAGE_ICON "${ICONS_DIR}\\\\CharmNSISHeader.bmp" )
        SET( CPACK_NSIS_URL_INFO_ABOUT "http://www.kdab.com/" )
        SET( CPACK_NSIS_INSTALLED_ICON_NAME "Charm${CMAKE_EXECUTABLE_SUFFIX}" )
        SET( CPACK_NSIS_MENU_LINKS
            "${LICENSE_FILE}" "License"
            "${README_FILE}" "Readme"
        )
        SET( CPACK_NSIS_MUI_FINISHPAGE_RUN "${CPACK_NSIS_INSTALLED_ICON_NAME}" )
    ELSEIF( APPLE )
        SET( CPACK_GENERATOR "DragNDrop" )
        SET( CPACK_DMG_FORMAT "UDBZ" )
        SET( CPACK_DMG_VOLUME_NAME "Charm" )
        SET( CPACK_SYSTEM_NAME "OSX" )
        SET( CPACK_PACKAGE_FILE_NAME "Charm-${Charm_VERSION}" )
        SET( CPACK_PACKAGE_ICON "${ICONS_DIR}/CharmDMG.icns" )
        SET( CPACK_DMG_DS_STORE "${ICONS_DIR}/CharmDSStore" )
        SET( CPACK_DMG_BACKGROUND_IMAGE "${ICONS_DIR}/CharmDMGBackground.png" )
    ELSEIF( UNIX )
        SET( CPACK_SYSTEM_NAME
            "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}"
        )
    ENDIF()

    INCLUDE( CPack )
ENDIF()

=== Charm/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${Charm_SOURCE_DIR} ${Charm_BINARY_DIR} )

if(POLICY CMP0020)
    CMAKE_POLICY(SET CMP0020 NEW)
endif()

SET(
    CharmApplication_SRCS
    ApplicationCore.cpp
    Data.cpp
    EventModelAdapter.cpp
    EventModelFilter.cpp
    GUIState.cpp
    ModelConnector.cpp
    ViewFilter.cpp
    TaskModelAdapter.cpp
    ViewHelpers.cpp
    WeeklySummary.cpp
    UndoCharmCommandWrapper.cpp
    Commands/CommandRelayCommand.cpp
    Commands/CommandModifyEvent.cpp
    Commands/CommandDeleteEvent.cpp
    Commands/CommandSetAllTasks.cpp
    Commands/CommandAddTask.cpp
    Commands/CommandModifyTask.cpp
    Commands/CommandDeleteTask.cpp
    Commands/CommandMakeEvent.cpp
    Commands/CommandExportToXml.cpp
    Commands/CommandImportFromXml.cpp
    Commands/CommandMakeAndActivateEvent.cpp
    HttpClient/HttpJob.cpp
    HttpClient/GetProjectCodesJob.cpp
    HttpClient/UploadTimesheetJob.cpp
    HttpClient/GetUserInfoJob.cpp
    HttpClient/CheckForUpdatesJob.cpp
    Idle/IdleDetector.cpp
    Reports/TimesheetInfo.cpp
    Reports/MonthlyTimesheetXmlWriter.cpp
    Reports/WeeklyTimesheetXmlWriter.cpp
    Widgets/ActivityReport.cpp
    Widgets/BillDialog.cpp
    Widgets/CharmPreferences.cpp
    Widgets/CharmWindow.cpp
    Widgets/CharmAboutDialog.cpp
    Widgets/CharmNewReleaseDialog.cpp
    Widgets/CommentEditorPopup.cpp
    Widgets/ConfigurationDialog.cpp
    Widgets/DateEntrySyncer.cpp
    Widgets/EnterVacationDialog.cpp
    Widgets/EventEditor.cpp
    Widgets/EventEditorDelegate.cpp
    Widgets/EventView.cpp
    Widgets/EventWindow.cpp
    Widgets/ExpandStatesHelper.cpp
    Widgets/HttpJobProgressDialog.cpp
    Widgets/IdleCorrectionDialog.cpp
    Widgets/MessageBox.cpp
    Widgets/MonthlyTimesheet.cpp
    Widgets/MonthlyTimesheetConfigurationDialog.cpp
    Widgets/ReportConfigurationDialog.cpp
    Widgets/ReportPreviewWindow.cpp
    Widgets/SelectTaskDialog.cpp
    Widgets/TaskIdDialog.cpp
    Widgets/TaskEditor.cpp
    Widgets/TasksView.cpp
    Widgets/TasksViewDelegate.cpp
    Widgets/TasksWindow.cpp
    Widgets/TimeTrackingView.cpp
    Widgets/TimeTrackingWindow.cpp
    Widgets/TimeTrackingTaskSelector.cpp
    Widgets/TrayIcon.cpp
    Widgets/Timesheet.cpp
    Widgets/WeeklyTimesheet.cpp
    Widgets/NotificationPopup.cpp
    Widgets/FindAndReplaceEventsDialog.cpp
)

SET(CharmApplication_LIBS)

IF( CHARM_CI_SUPPORT )
    LIST( APPEND CharmApplication_SRCS
        CI/CharmCommandInterface.cpp
        CI/CharmCommandServer.cpp
        CI/CharmCommandSession.cpp
        )
    IF( CHARM_CI_LOCALSERVER )
        LIST( APPEND CharmApplication_SRCS CI/CharmLocalCommandServer.cpp )
    ENDIF()
    IF( CHARM_CI_TCPSERVER )
        LIST( APPEND CharmApplication_SRCS CI/CharmTCPCommandServer.cpp )
    ENDIF()
ENDIF()

IF( CHARM_IDLE_DETECTION )
    IF( APPLE )
        LIST( APPEND CharmApplication_SRCS Idle/MacIdleDetector.mm )
    ELSEIF( WIN32 )
        LIST( APPEND CharmApplication_SRCS Idle/WindowsIdleDetector.cpp )
    ELSEIF( UNIX )
        FIND_PACKAGE( X11 )
        IF( X11_FOUND AND X11_Xscreensaver_LIB )
            MESSAGE( "X11 idle detection enabled." )
            INCLUDE_DIRECTORIES( ${X11_INCLUDE_DIR} )
            LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
            LIST( APPEND CharmApplication_LIBS ${X11_X11_LIB} ${X11_Xscreensaver_LIB} )
            SET( CHARM_IDLE_DETECTION_AVAILABLE_X11 "1" CACHE INTERNAL "" )
        ELSE()
            MESSAGE( "Install X11/XScreenSaver headers and library for X11 idle detection." )
        ENDIF()
    ENDIF()
ENDIF()

LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )

IF (APPLE)
    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )

    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )

    FIND_LIBRARY( SECURITY_LIBRARY Security )
    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )

    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
ELSEIF ( WIN32 )
    LIST( APPEND CharmApplication_SRCS Keychain/keychain_win.cpp )
ELSEIF ( UNIX )
    IF (HAVE_DBUS)
        LIST( APPEND CharmApplication_SRCS Keychain/gnomekeyring.cpp Keychain/keychain_unix.cpp )
        QT_ADD_DBUS_INTERFACE( CharmApplication_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Keychain/org.kde.KWallet.xml kwallet_interface KWalletInterface )
        LIST( APPEND CharmApplication_LIBS ${QT_QTDBUS_LIBRARY} )
    ELSE()
        LIST( APPEND CharmApplication_SRCS Keychain/keychain_unsecure.cpp )
    ENDIF()
ENDIF()

QT_WRAP_UI(
    UiGenerated_SRCS
    Widgets/CommentEditorPopup.ui
    Widgets/ConfigurationDialog.ui
    Widgets/CharmPreferences.ui
    Widgets/TaskIdDialog.ui
    Widgets/TaskEditor.ui
    Widgets/EnterVacationDialog.ui
    Widgets/EventEditor.ui
    Widgets/SelectTaskDialog.ui
    Widgets/CharmAboutDialog.ui
    Widgets/CharmNewReleaseDialog.ui
    Widgets/IdleCorrectionDialog.ui
    Widgets/ActivityReportConfigurationDialog.ui
    Widgets/WeeklyTimesheetConfigurationDialog.ui
    Widgets/MonthlyTimesheetConfigurationDialog.ui
    Widgets/ReportPreviewWindow.ui
    Widgets/NotificationPopup.ui
    Widgets/FindAndReplaceEventsDialog.ui
)

QT_ADD_RESOURCES( Resources_SRCS CharmResources.qrc )

ADD_LIBRARY(
    CharmApplication STATIC
    ${CharmApplication_SRCS} ${UiGenerated_SRCS}
)
TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS})

SET( Charm_SRCS Charm.cpp )

IF( APPLE )
    IF( CHARM_MAC_HIGHRES_SUPPORT_ENABLED )
        SET( MACOSX_BUNDLE_HIGHRESOLUTION_CAPABLE "true")
    ELSE()
        SET( MACOSX_BUNDLE_HIGHRESOLUTION_CAPABLE "false")
    ENDIF()
    SET( MACOSX_BUNDLE_INFO_STRING "Charm ${Charm_VERSION}" )
    SET( MACOSX_BUNDLE_BUNDLE_VERSION "Charm ${Charm_VERSION}" )
    SET( MACOSX_BUNDLE_LONG_VERSION_STRING "Charm ${Charm_VERSION}" )
    SET( MACOSX_BUNDLE_SHORT_VERSION_STRING "${Charm_VERSION}" )
    SET( MACOSX_BUNDLE_COPYRIGHT "2006-2014 KDAB" )
    SET( MACOSX_BUNDLE_ICON_FILE "Charm.icns" )
    SET( MACOSX_BUNDLE_GUI_IDENTIFIER "com.kdab" )
    SET( MACOSX_BUNDLE_BUNDLE_NAME "Charm" )

    SET( RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/Charm.app/Contents/Resources"	)
    SET( ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}" )
    FILE( MAKE_DIRECTORY ${RESOURCES} )
    FILE( COPY ${ICON} DESTINATION ${RESOURCES} )
ENDIF()

IF( MSVC )
    SET( Resources_SRCS ${Resources_SRCS} Charm.rc )
ENDIF()

ADD_EXECUTABLE( ${Charm_EXECUTABLE} WIN32 MACOSX_BUNDLE ${Charm_SRCS} ${Resources_SRCS} )
TARGET_LINK_LIBRARIES( ${Charm_EXECUTABLE} CharmApplication CharmCore ${QT_LIBRARIES} )
IF( WIN32 )
    TARGET_LINK_LIBRARIES( ${Charm_EXECUTABLE} Crypt32 )
ENDIF()
MESSAGE( STATUS "Charm will be installed to ${CMAKE_INSTALL_PREFIX}" )

IF( UNIX AND NOT APPLE )
    SET( XDG_APPS_INSTALL_DIR share/applications )
    INSTALL( FILES charmtimetracker.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )
    INSTALL( FILES Icons/Charm-128x128.png DESTINATION share/icons/hicolor/128x128/apps )
ENDIF()

INSTALL( TARGETS ${Charm_EXECUTABLE} DESTINATION ${BIN_INSTALL_DIR} )
IF( APPLE )
    SET( EXECUTABLE ${Charm_EXECUTABLE}.app )
    set_target_properties( ${Charm_EXECUTABLE} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in )
ELSE()
    SET( EXECUTABLE ${Charm_EXECUTABLE}${CMAKE_EXECUTABLE_SUFFIX} )
ENDIF()

EXECUTE_PROCESS(
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR}/${EXECUTABLE} ${Charm_BINARY_DIR}/${EXECUTABLE}
)

# Only support CPack packaging on newer versions of CMake.
IF( NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.4" )
    IF( CMAKE_BUILD_TYPE MATCHES "^([Dd][Ee][Bb][Uu][Gg])" )
        SET( CMAKE_INSTALL_DEBUG_LIBRARIES_ONLY TRUE )
    ENDIF()

    SET( CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION "${BIN_INSTALL_DIR}" )
    INCLUDE( InstallRequiredSystemLibraries )

    IF( NOT BIN_INSTALL_DIR STREQUAL "." )
        SET( EXECUTABLE ${BIN_INSTALL_DIR}/${EXECUTABLE} )
    ENDIF()

    IF( WIN32 )
        FIND_PACKAGE( OpenSSL REQUIRED )
        INSTALL( FILES ${OPENSSL_INCLUDE_DIR}/../libeay32.dll ${OPENSSL_INCLUDE_DIR}/../ssleay32.dll
                 DESTINATION ${BIN_INSTALL_DIR} )
    ENDIF()

    IF( APPLE OR WIN32 )
        INCLUDE( DeployQt4 )
        INSTALL_QT4_EXECUTABLE( "${EXECUTABLE}" "qsqlite" )
    ENDIF()

    # Plugin deployment for Windows/Qt5
    IF( WIN32 AND Qt5Core_FOUND )
        # Deploy platform plugin to platforms/ (plugins/platforms isn't found, for whatever reason)
        GET_TARGET_PROPERTY(_qmake_executable Qt5::qmake IMPORTED_LOCATION)
        EXEC_PROGRAM( ${_qmake_executable} ARGS -query QT_INSTALL_PLUGINS OUTPUT_VARIABLE _loc )
        INSTALL( FILES ${_loc}/platforms/qwindows.dll DESTINATION platforms )
        # Deploy qsqlite plugin
        GET_TARGET_PROPERTY( _loc Qt5::QSQLiteDriverPlugin LOCATION )
        INSTALL( FILES ${_loc} DESTINATION plugins/sqldrivers )
    ENDIF()
ENDIF()

=== Tests/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${Charm_SOURCE_DIR} )

if(POLICY CMP0020)
    CMAKE_POLICY(SET CMP0020 NEW)
endif()

SET( TestApplication_SRCS TestApplication.cpp )

SET( TEST_LIBRARIES CharmCore ${QT_QTTEST_LIBRARY} ${QT_LIBRARIES} )

QT_ADD_RESOURCES( TestDataResources_SRCS TestData.qrc )

IF( APPLE )
    FIND_LIBRARY( SECURITY_FRAMEWORK FRAMEWORK required NAMES Security )
    LIST( APPEND TEST_LIBRARIES ${SECURITY_FRAMEWORK} )
ENDIF()

SET( SqLiteStorageTests_SRCS SqLiteStorageTests.cpp )
ADD_EXECUTABLE( SqLiteStorageTests ${SqLiteStorageTests_SRCS} )
TARGET_LINK_LIBRARIES( SqLiteStorageTests ${TEST_LIBRARIES} )
ADD_TEST( NAME SqLiteStorageTests COMMAND SqLiteStorageTests )

SET( ControllerTests_SRCS ControllerTests.cpp )
ADD_EXECUTABLE( ControllerTests ${ControllerTests_SRCS} )
TARGET_LINK_LIBRARIES( ControllerTests ${TEST_LIBRARIES} )
ADD_TEST( NAME ControllerTests COMMAND ControllerTests )

SET( DatesTests_SRCS DatesTests.cpp )
ADD_EXECUTABLE( DatesTests ${DatesTests_SRCS} )
TARGET_LINK_LIBRARIES( DatesTests ${TEST_LIBRARIES} )

SET( SmartNameCacheTests_SRCS SmartNameCacheTests.cpp )
ADD_EXECUTABLE( SmartNameCacheTests ${SmartNameCacheTests_SRCS} )
TARGET_LINK_LIBRARIES( SmartNameCacheTests ${TEST_LIBRARIES} )

SET( CharmDataModelTests_SRCS CharmDataModelTests.cpp )
ADD_EXECUTABLE( CharmDataModelTests ${CharmDataModelTests_SRCS} )
TARGET_LINK_LIBRARIES( CharmDataModelTests ${TEST_LIBRARIES} )
ADD_TEST( NAME CharmDataModelTests COMMAND CharmDataModelTests )

SET(
    BackendIntegrationTests_SRCS
    BackendIntegrationTests.cpp
    ${TestApplication_SRCS}
)
ADD_EXECUTABLE( BackendIntegrationTests ${BackendIntegrationTests_SRCS} )
TARGET_LINK_LIBRARIES( BackendIntegrationTests ${TEST_LIBRARIES} )
ADD_TEST( NAME BackendIntegrationTests COMMAND BackendIntegrationTests )

SET( TaskStructureTests_SRCS TaskStructureTests.cpp )
ADD_EXECUTABLE(
    TaskStructureTests
    ${TaskStructureTests_SRCS}
    ${TestDataResources_SRCS}
)
TARGET_LINK_LIBRARIES( TaskStructureTests ${TEST_LIBRARIES} )
ADD_TEST( NAME TaskStructureTests COMMAND TaskStructureTests )

SET( TimeSpanTests_SRCS TimeSpanTests.cpp )
ADD_EXECUTABLE( TimeSpanTests ${TimeSpanTests_SRCS} )
TARGET_LINK_LIBRARIES( TimeSpanTests ${TEST_LIBRARIES} )

SET( XmlSerializationTests_SRCS XmlSerializationTests.cpp )
ADD_EXECUTABLE(
    XmlSerializationTests
    ${XmlSerializationTests_SRCS}
    ${TestDataResources_SRCS}
)
TARGET_LINK_LIBRARIES( XmlSerializationTests ${TEST_LIBRARIES} )
ADD_TEST( NAME XmlSerializationTests COMMAND XmlSerializationTests )

SET( ImportExportTests_SRCS ImportExportTests.cpp ${TestApplication_SRCS} )
ADD_EXECUTABLE(
    ImportExportTests
    ${ImportExportTests_SRCS}
    ${TestDataResources_SRCS}
)
TARGET_LINK_LIBRARIES( ImportExportTests ${TEST_LIBRARIES} )
ADD_TEST( NAME ImportExportTests COMMAND ImportExportTests )

SET( SqlTransactionTests_SRCS SqlTransactionTests.cpp )
ADD_EXECUTABLE( SqlTransactionTests ${SqlTransactionTests_SRCS} )
TARGET_LINK_LIBRARIES( SqlTransactionTests ${TEST_LIBRARIES} )

IF( CHARM_DATABASE_CONFIGURATION )
    ADD_TEST( NAME SqlTransactionTests COMMAND SqlTransactionTests )
    SET_PROPERTY(
        TEST SqlTransactionTests
        PROPERTY ENVIRONMENT
        "CHARM_DATABASE_CONFIGURATION=${CHARM_DATABASE_CONFIGURATION}"
    )

    SET(TimeSheetProcessorTests_SRCS TimeSheetProcessorTests.cpp
                                     ${Charm_SOURCE_DIR}/Tools/TimesheetProcessor/Operations.cpp
                                     ${Charm_SOURCE_DIR}/Tools/TimesheetProcessor/CommandLine.cpp
                                     ${Charm_SOURCE_DIR}/Tools/TimesheetProcessor/Database.cpp
    )
    ADD_EXECUTABLE(TimeSheetProcessorTests
                   ${TimeSheetProcessorTests_SRCS}
                   ${TestDataResources_SRCS}
    )
    TARGET_LINK_LIBRARIES(TimeSheetProcessorTests ${TEST_LIBRARIES} )
    ADD_TEST(NAME TimeSheetProcessorTests COMMAND TimeSheetProcessorTests )

ENDIF()

SET( UpdateCheckerTests_SRCS ${Charm_SOURCE_DIR}/Charm/HttpClient/CheckForUpdatesJob.cpp UpdateCheckerTests.cpp )
ADD_EXECUTABLE( UpdateCheckerTests ${UpdateCheckerTests_SRCS} )
TARGET_LINK_LIBRARIES( UpdateCheckerTests ${TEST_LIBRARIES} )

=== Tools/TimesheetProcessor/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${Charm_SOURCE_DIR} ${Charm_BINARY_DIR} )

SET(
    TimesheetProcessor_SRCS
    main.cpp
    CommandLine.cpp
    Operations.cpp
    Database.cpp
)

ADD_EXECUTABLE( TimesheetProcessor ${TimesheetProcessor_SRCS} )
TARGET_LINK_LIBRARIES( TimesheetProcessor CharmCore ${QT_LIBRARIES} )
INSTALL( TARGETS TimesheetProcessor DESTINATION ${BIN_INSTALL_DIR} )

=== debian/changelog ===
charmtimetracker (1.10.0-1) unstable; urgency=medium

  * Initial release (Closes: #800420)

 -- Sandro Knauß <bugs@sandroknauss.de>  Tue, 29 Sep 2015 09:02:47 +0200

=== debian/control ===
Source: charmtimetracker
Section: misc
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <bugs@sandroknauss.de>
Build-Depends: debhelper (>= 9),
               cmake,
               libqt5sql5-sqlite,
               qtbase5-dev,
               qt5keychain-dev,
               xauth,
               xvfb
Standards-Version: 3.9.6
Homepage: https://github.com/KDAB/Charm
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/charmtimetracker.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/charmtimetracker.git

Package: charmtimetracker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross-Platform Time Tracker
 It is built around two major ideas - tasks and events.
 Tasks are the things time is spend on, repeatedly. Tasks
 are done in events.
 .
 For example, ironing laundry is a task. The laundry done
 for two hours on last Tuesday is an event in that task.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -DQT_NO_DEBUG_OUTPUT

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCharm_VERSION=$(DEB_VERSION_UPSTREAM)

override_dh_auto_test:
	xvfb-run dh_auto_test

## charmtimetracker 1.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
     SET( CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE )
 ENDIF()
 
-IF( APPLE AND CMAKE_INSTALL_PREFIX MATCHES "/usr/local" )
+IF( APPLE AND CMAKE_INSTALL_PREFIX STREQUAL "/usr/local" )
     SET( CMAKE_INSTALL_PREFIX "/Applications" )
 ENDIF()
 
@@ -37,9 +37,12 @@
 CMAKE_MINIMUM_REQUIRED( VERSION 2.6.0 )
 SET( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMake" )
 
-if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-  set(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
-endif()
+IF(CMAKE_COMPILER_IS_GNUCXX OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+    SET(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
+ENDIF()
+IF(MSVC)
+    SET(CMAKE_CXX_FLAGS "-D_USING_V110_SDK71_=1 ${CMAKE_CXX_FLAGS}")
+ENDIF()
 
 SET( CMAKE_AUTOMOC ON )
 
@@ -49,6 +52,8 @@
 IF( NOT CHARM_FORCE_QT4 )
     find_package( Qt5Core QUIET )
 ENDIF()
+
+set(QTKEYCHAIN_SYSTEM OFF)
 
 IF(Qt5Core_FOUND)
     find_package(Qt5Widgets REQUIRED)
@@ -56,6 +61,10 @@
     find_package(Qt5Network REQUIRED)
     find_package(Qt5Sql REQUIRED)
     find_package(Qt5Test REQUIRED)
+    find_package(Qt5Script REQUIRED)
+    if(WIN32)
+        find_package(Qt5WinExtras REQUIRED)
+    endif()
 
     find_package(Qt5PrintSupport)
     IF(Qt5PrintSupport_FOUND)
@@ -63,10 +72,16 @@
         set(QTPRINT_LIBRARIES ${Qt5PrintSupport_LIBRARIES})
     ENDIF()
 
+    find_package(Qt5Keychain QUIET)
+
+    IF(Qt5Keychain_FOUND)
+	set(QTKEYCHAIN_SYSTEM ON)
+    ENDIF()
+
     SET(CHARM_MAC_HIGHRES_SUPPORT_ENABLED ON)
 
     IF(WIN32)
-        SET(QT_PLATFORM_SPECIFIC_LIBRARIES Qt5::WinMain)
+        SET(QT_PLATFORM_SPECIFIC_LIBRARIES Qt5::WinMain Qt5::WinExtras)
     ELSE()
         SET(QT_PLATFORM_SPECIFIC_LIBRARIES)
     ENDIF()
@@ -108,29 +123,30 @@
     set(QT_QTTEST_LIBRARY ${Qt5Test_LIBRARIES})
 
     set(QT_LIBRARIES
-        ${Qt5Core_LIBRARIES}
-        ${Qt5Widgets_LIBRARIES}
-        ${Qt5Xml_LIBRARIES}
-        ${Qt5Network_LIBRARIES}
-        ${Qt5Sql_LIBRARIES}
-        ${QTPRINT_LIBRARIES}
-        ${QTDBUS_LIBRARIES}
+        Qt5::Core
+        Qt5::Widgets
+        Qt5::Xml
+        Qt5::Network
+        Qt5::Script
+        Qt5::Sql
+        Qt5::PrintSupport
+        ${QTKEYCHAIN_LIBRARIES}
         ${QT_PLATFORM_SPECIFIC_LIBRARIES}
     )
-
-    include_directories(
-        ${Qt5Core_INCLUDE_DIRS}
-        ${Qt5Widgets_INCLUDE_DIRS}
-        ${Qt5Xml_INCLUDE_DIRS}
-        ${Qt5Network_INCLUDE_DIRS}
-        ${Qt5Sql_INCLUDE_DIRS}
-    )
-
-    SET( CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}" )
+    if (TARGET Qt5::DBus)
+        list(APPEND QT_LIBRARIES Qt5::DBus)
+    endif()
 ELSE()
     # No Qt5 found, try Qt4
-    find_package(Qt4 COMPONENTS QtMain QtCore QtGui QtSql QtXml QtNetwork REQUIRED)
+    find_package(Qt4 COMPONENTS QtMain QtCore QtGui QtSql QtXml QtNetwork QtScript REQUIRED)
     INCLUDE( UseQt4 )
+
+    find_package(QtKeychain QUIET)
+    LIST(APPEND QT_LIBRARIES ${QTKEYCHAIN_LIBRARIES})
+
+    IF(QtKeychain_FOUND)
+        set(QTKEYCHAIN_SYSTEM ON)
+    ENDIF()
 
     SET(CHARM_MAC_HIGHRES_SUPPORT_ENABLED OFF)
 
@@ -152,7 +168,7 @@
         endmacro()
     ENDIF()
 
-    include_directories(${QT_INCLUDES})
+    include_directories(${QT_INCLUDES} ${QTKEYCHAIN_INCLUDE_DIRS})
     #set(QTCORE_LIBRARIES ${QT_QTCORE_LIBRARY})
 
     macro(qt_wrap_cpp)
@@ -189,28 +205,34 @@
 
 IF( CMAKE_COMPILER_IS_GNUCXX )
     # Add additional GCC options.
-    ADD_DEFINITIONS(
-        -Wall -Wundef -Wcast-align -Wchar-subscripts -Wpointer-arith
-        -Wwrite-strings -Wpacked -Wformat-security
-        -Wmissing-format-attribute -Wold-style-cast
-    )
-    ADD_DEFINITIONS( -fvisibility=hidden )
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wundef -Wcast-align -Wchar-subscripts -Wpointer-arith")
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wwrite-strings -Wpacked -Wformat-security")
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wmissing-format-attribute -Wold-style-cast")
+    IF(NOT WIN32)
+        SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden ")
+    ENDIF()
 ELSEIF( CMAKE_CXX_COMPILER MATCHES "clang" )
-    ADD_DEFINITIONS( -Wall -Wextra -Wno-unused-parameter )
-    ADD_DEFINITIONS( -fvisibility=hidden )
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter" )
+    IF(NOT WIN32)
+        SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden" )
+    ENDIF()
 ENDIF()
 
 
 IF( UNIX AND NOT APPLE )
     set( Charm_EXECUTABLE charmtimetracker )
-    SET( BIN_INSTALL_DIR bin )
-    SET( DOC_INSTALL_DIR share/doc/${Charm_EXECUTABLE} )
 ELSE()
     set( Charm_EXECUTABLE Charm )
-    SET( BIN_INSTALL_DIR . )
+ENDIF()
+
+SET( BIN_INSTALL_DIR bin )
+SET( DOC_INSTALL_DIR share/doc/${Charm_EXECUTABLE} )
+SET( ICONS_DIR "${CMAKE_SOURCE_DIR}/Charm/Icons" )
+
+IF( CHARM_PREPARE_DEPLOY AND WIN32 OR APPLE)
+SET( BIN_INSTALL_DIR . )
     SET( DOC_INSTALL_DIR . )
 ENDIF()
-SET( ICONS_DIR "${CMAKE_SOURCE_DIR}/Charm/Icons" )
 
 OPTION( CHARM_IDLE_DETECTION "Build the Charm idle detector" ON )
 OPTION( CHARM_TIMESHEET_TOOLS "Build the Charm timesheet tools" OFF )
@@ -221,6 +243,8 @@
     OPTION( CHARM_CI_TCPSERVER "Build Charm with TCP command interface support" ON )
     OPTION( CHARM_CI_LOCALSERVER "Build Charm with local socket command interface support" ON )
 ENDIF()
+
+OPTION(CHARM_PREPARE_DEPLOY "Deploy dependencies with install target(Windows, Apple)" ON)
 
 ADD_SUBDIRECTORY( Core )
 ADD_SUBDIRECTORY( Charm )

=== Charm/CMakeLists.txt ===
--- 
+++ 
@@ -50,7 +50,6 @@
     Widgets/EventEditor.cpp
     Widgets/EventEditorDelegate.cpp
     Widgets/EventView.cpp
-    Widgets/EventWindow.cpp
     Widgets/ExpandStatesHelper.cpp
     Widgets/HttpJobProgressDialog.cpp
     Widgets/IdleCorrectionDialog.cpp
@@ -64,7 +63,6 @@
     Widgets/TaskEditor.cpp
     Widgets/TasksView.cpp
     Widgets/TasksViewDelegate.cpp
-    Widgets/TasksWindow.cpp
     Widgets/TimeTrackingView.cpp
     Widgets/TimeTrackingWindow.cpp
     Widgets/TimeTrackingTaskSelector.cpp
@@ -73,6 +71,7 @@
     Widgets/WeeklyTimesheet.cpp
     Widgets/NotificationPopup.cpp
     Widgets/FindAndReplaceEventsDialog.cpp
+    Widgets/WidgetUtils.cpp
 )
 
 SET(CharmApplication_LIBS)
@@ -97,42 +96,57 @@
     ELSEIF( WIN32 )
         LIST( APPEND CharmApplication_SRCS Idle/WindowsIdleDetector.cpp )
     ELSEIF( UNIX )
-        FIND_PACKAGE( X11 )
-        IF( X11_FOUND AND X11_Xscreensaver_LIB )
-            MESSAGE( "X11 idle detection enabled." )
-            INCLUDE_DIRECTORIES( ${X11_INCLUDE_DIR} )
-            LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
-            LIST( APPEND CharmApplication_LIBS ${X11_X11_LIB} ${X11_Xscreensaver_LIB} )
-            SET( CHARM_IDLE_DETECTION_AVAILABLE_X11 "1" CACHE INTERNAL "" )
+        SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/Modules/ )
+        IF( Qt5Core_FOUND )
+            FIND_PACKAGE( XCB )
+            IF( XCB_INCLUDE_PATH_FOUND AND XCB_LIBRARIES_FOUND AND XCB_SCREENSAVER_LIBRARIES_FOUND  )
+                INCLUDE_DIRECTORIES( ${XCB_INCLUDE_DIRS} )
+                LIST( APPEND CharmApplication_LIBS ${XCB_LIBRARIES} ${XCB_SCREENSAVER_LIBRARIES} )
+                LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "1" CACHE INTERNAL "" )
+            ELSE()
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "0" CACHE INTERNAL "" )
+                MESSAGE( "QT5: Install Xcb headers and library for Xcb idle detection." )
+            ENDIF()
         ELSE()
-            MESSAGE( "Install X11/XScreenSaver headers and library for X11 idle detection." )
+            FIND_PACKAGE( X11 )
+            IF(  X11_FOUND AND X11_Xscreensaver_LIB)
+                INCLUDE_DIRECTORIES( ${X11_INCLUDE_DIR} )
+                LIST( APPEND CharmApplication_LIBS ${X11_X11_LIB} ${X11_Xscreensaver_LIB} )
+                LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "1" CACHE INTERNAL "" )
+            ELSE()
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "0" CACHE INTERNAL "" )
+                MESSAGE( "QT4: Install X11/XScreenSaver headers and library for X11 idle detection." )
+            ENDIF()
         ENDIF()
     ENDIF()
 ENDIF()
 
-LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )
-
-IF (APPLE)
-    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )
-
-    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
-    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
-
-    FIND_LIBRARY( SECURITY_LIBRARY Security )
-    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )
-
-    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
-    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
-ELSEIF ( WIN32 )
-    LIST( APPEND CharmApplication_SRCS Keychain/keychain_win.cpp )
-ELSEIF ( UNIX )
-    IF (HAVE_DBUS)
-        LIST( APPEND CharmApplication_SRCS Keychain/gnomekeyring.cpp Keychain/keychain_unix.cpp )
-        QT_ADD_DBUS_INTERFACE( CharmApplication_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Keychain/org.kde.KWallet.xml kwallet_interface KWalletInterface )
-        LIST( APPEND CharmApplication_LIBS ${QT_QTDBUS_LIBRARY} )
-    ELSE()
-        LIST( APPEND CharmApplication_SRCS Keychain/keychain_unsecure.cpp )
-    ENDIF()
+IF (NOT QTKEYCHAIN_SYSTEM)
+	LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )
+	IF (APPLE)
+	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )
+
+	    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
+	    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
+
+	    FIND_LIBRARY( SECURITY_LIBRARY Security )
+	    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )
+
+	    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
+	    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
+	ELSEIF ( WIN32 )
+	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_win.cpp )
+	ELSEIF ( UNIX )
+	    IF (HAVE_DBUS)
+		LIST( APPEND CharmApplication_SRCS Keychain/gnomekeyring.cpp Keychain/keychain_unix.cpp )
+		QT_ADD_DBUS_INTERFACE( CharmApplication_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Keychain/org.kde.KWallet.xml kwallet_interface KWalletInterface )
+		LIST( APPEND CharmApplication_LIBS ${QT_QTDBUS_LIBRARY} )
+	    ELSE()
+		LIST( APPEND CharmApplication_SRCS Keychain/keychain_unsecure.cpp )
+	    ENDIF()
+	ENDIF()
 ENDIF()
 
 QT_WRAP_UI(
@@ -162,7 +176,7 @@
     CharmApplication STATIC
     ${CharmApplication_SRCS} ${UiGenerated_SRCS}
 )
-TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS})
+TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS} ${QT_LIBRARIES})
 
 SET( Charm_SRCS Charm.cpp )
 
@@ -187,7 +201,7 @@
     FILE( COPY ${ICON} DESTINATION ${RESOURCES} )
 ENDIF()
 
-IF( MSVC )
+IF(WIN32)
     SET( Resources_SRCS ${Resources_SRCS} Charm.rc )
 ENDIF()
 
@@ -217,7 +231,7 @@
 )
 
 # Only support CPack packaging on newer versions of CMake.
-IF( NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.4" )
+IF( NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.4" AND CHARM_PREPARE_DEPLOY )
     IF( CMAKE_BUILD_TYPE MATCHES "^([Dd][Ee][Bb][Uu][Gg])" )
         SET( CMAKE_INSTALL_DEBUG_LIBRARIES_ONLY TRUE )
     ENDIF()
@@ -249,5 +263,7 @@
         # Deploy qsqlite plugin
         GET_TARGET_PROPERTY( _loc Qt5::QSQLiteDriverPlugin LOCATION )
         INSTALL( FILES ${_loc} DESTINATION plugins/sqldrivers )
-    ENDIF()
-ENDIF()
+        # Install qt.conf (prevents plugins from the built-in Qt path to be used)
+        INSTALL(FILES qt.conf.in.windows RENAME qt.conf DESTINATION .)
+    ENDIF()
+ENDIF()

=== Tests/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,14 @@
 ADD_EXECUTABLE( ControllerTests ${ControllerTests_SRCS} )
 TARGET_LINK_LIBRARIES( ControllerTests ${TEST_LIBRARIES} )
 ADD_TEST( NAME ControllerTests COMMAND ControllerTests )
+
+SET( EventModelFilterTests_SRCS
+     ${Charm_SOURCE_DIR}/Charm/EventModelAdapter.cpp
+     ${Charm_SOURCE_DIR}/Charm/EventModelFilter.cpp
+     EventModelFilterTests.cpp
+)
+ADD_EXECUTABLE( EventModelFilterTests ${EventModelFilterTests_SRCS} )
+TARGET_LINK_LIBRARIES( EventModelFilterTests ${TEST_LIBRARIES} )
 
 SET( DatesTests_SRCS DatesTests.cpp )
 ADD_EXECUTABLE( DatesTests ${DatesTests_SRCS} )

=== debian/changelog ===
charmtimetracker (1.11.1-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream release
  * Add qtscript5-dev to Build-Deps
  * Bump Standards-Version (no change needed).
  * Update copyright file
  * Patch updates:
    - Remove upstream applied patches (use system qtkeychain)
    - Update patch hunks
    - Add patch to fix the licenses in cmake folder (source: upstream)
  * Activate hardening flags

  [ Maximiliano Curia ]
  * Make sure -fPIC is present in the buildflags (Closes: #828878) Thanks to
    Chris Lamb for the report.

 -- Sandro Knauß <bugs@sandroknauss.de>  Thu, 26 May 2016 11:13:26 +0200

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
                libqt5sql5-sqlite,
                qtbase5-dev,
                qt5keychain-dev,
+               qtscript5-dev,
                xauth,
                xvfb
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/KDAB/Charm
 Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/charmtimetracker.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/charmtimetracker.git

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,10 @@
 #!/usr/bin/make -f
-export DH_VERBOSE = 1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+include /usr/share/dpkg/buildflags.mk
 
 include /usr/share/dpkg/default.mk
-export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -DQT_NO_DEBUG_OUTPUT
+export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -DQT_NO_DEBUG_OUTPUT -fPIC
 
 %:
 	dh $@ --parallel

## charmtimetracker 1.11.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -291,7 +291,6 @@
             "${LICENSE_FILE}" "License"
             "${README_FILE}" "Readme"
         )
-        SET( CPACK_NSIS_MUI_FINISHPAGE_RUN "${CPACK_NSIS_INSTALLED_ICON_NAME}" )
     ELSEIF( APPLE )
         SET( CPACK_GENERATOR "DragNDrop" )
         SET( CPACK_DMG_FORMAT "UDBZ" )

=== Charm/CMakeLists.txt ===
--- 
+++ 
@@ -76,6 +76,19 @@
 
 SET(CharmApplication_LIBS)
 
+IF (APPLE)
+    LIST(APPEND CharmApplication_SRCS MacApplicationCore.mm)
+
+    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
+    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
+
+    FIND_LIBRARY( SECURITY_LIBRARY Security )
+    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )
+
+    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
+    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
+ENDIF()
+
 IF( CHARM_CI_SUPPORT )
     LIST( APPEND CharmApplication_SRCS
         CI/CharmCommandInterface.cpp
@@ -126,7 +139,7 @@
 IF (NOT QTKEYCHAIN_SYSTEM)
 	LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )
 	IF (APPLE)
-	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )
+	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp )
 
 	    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
 	    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
@@ -177,6 +190,9 @@
     ${CharmApplication_SRCS} ${UiGenerated_SRCS}
 )
 TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS} ${QT_LIBRARIES})
+IF(QTKEYCHAIN_SYSTEM)
+    TARGET_INCLUDE_DIRECTORIES(CharmApplication PRIVATE ${QTKEYCHAIN_INCLUDE_DIRS})
+ENDIF()
 
 SET( Charm_SRCS Charm.cpp )
 
@@ -263,6 +279,9 @@
         # Deploy qsqlite plugin
         GET_TARGET_PROPERTY( _loc Qt5::QSQLiteDriverPlugin LOCATION )
         INSTALL( FILES ${_loc} DESTINATION plugins/sqldrivers )
+        # Deploy windowsprintersupport plugin
+        GET_TARGET_PROPERTY( _loc Qt5::QWindowsPrinterSupportPlugin LOCATION )
+        INSTALL( FILES ${_loc} DESTINATION plugins/printsupport )
         # Install qt.conf (prevents plugins from the built-in Qt path to be used)
         INSTALL(FILES qt.conf.in.windows RENAME qt.conf DESTINATION .)
     ENDIF()

=== Core/CMakeLists.txt ===
if(POLICY CMP0020)
    CMAKE_POLICY(SET CMP0020 NEW)
endif()

SET(
    CharmCore_SRCS
    CharmConstants.cpp
    CharmExceptions.cpp
    Controller.cpp
    Dates.cpp
    SqlRaiiTransactor.cpp
    SqLiteStorage.cpp
    MySqlStorage.cpp
    Configuration.cpp
    SqlStorage.cpp
    Event.cpp
    Task.cpp
    TaskListMerger.cpp
    State.cpp
    CharmDataModel.cpp
    TaskTreeItem.cpp
    TimeSpans.cpp
    CharmCommand.cpp
    SmartNameCache.cpp
    XmlSerialization.cpp
)

ADD_LIBRARY( CharmCore STATIC ${CharmCore_SRCS} )

TARGET_LINK_LIBRARIES( CharmCore ${QT_LIBRARIES} )

=== debian/changelog ===
charmtimetracker (1.11.4-2) unstable; urgency=medium

  * Fix "Missing binary dependency on libqt5sql5-sqlite" (Closes: #873918)
    - Adding libqt5sql5-sqlite to depends list of charmtimetracker.
  * Bump Standards-Version to 4.1.0 (no change needed).

 -- Sandro Knauß <hefee@debian.org>  Sat, 09 Sep 2017 16:59:35 +0200

charmtimetracker (1.11.4-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream version.
  * Change my own mailaddress to hefee@debian.org.
  * Add support for Xcb idle detection (Closes: #834885).
  * Use secure URI for VCS field.

 -- Sandro Knauß <hefee@debian.org>  Thu, 10 Nov 2016 09:33:30 +0100

=== debian/control ===
Source: charmtimetracker
Section: misc
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake,
               debhelper (>= 10),
               libqt5sql5-sqlite,
               libxcb-screensaver0-dev,
               libxcb1-dev,
               qt5keychain-dev,
               qtbase5-dev,
               qtscript5-dev,
               xauth,
               xvfb
Standards-Version: 4.1.0
Homepage: https://github.com/KDAB/Charm
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-extras/charmtimetracker.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/charmtimetracker.git

Package: charmtimetracker
Architecture: any
Depends: libqt5sql5-sqlite, ${misc:Depends}, ${shlibs:Depends}
Description: Cross-Platform Time Tracker
 It is built around two major ideas - tasks and events.
 Tasks are the things time is spend on, repeatedly. Tasks
 are done in events.
 .
 For example, ironing laundry is a task. The laundry done
 for two hours on last Tuesday is an event in that task.
